ECB (Emacs Code Browser) is a source code browser for Emacs. It is a
global minor-mode which displays a couple of windows that can be used
to browse directories, files and methods. It supports method parsing
for Java, C, C++, Elisp and some more.

*NOTE*: Experienced ECB users find a complete alphabetical list of all
commands and user-options in Interactive ECB commands and
Customizable options.

The latest version of ECB can always be found at the URL
<http://home.swipnet.se/mayhem/ecb.html>.

To send bug reports, or participate in discussions about ECB, use the
mailing list <ecb-list@lists.sourceforge.net> via the URL
<http://lists.sourceforge.net/lists/listinfo/ecb-list>.

Installation and first steps of ECB
***********************************

This chapter describes how to install ECB and what are the first steps
after activation of ECB

Installation of ECB
===================

1. Unpack the ECB archive.

2. Read the file `README' in the ECB-directory and install the required
   semantic- and eieio-version.

   *Note*: ECB maybe requires a newer version of these libraries than
   shipped with Emacs or XEmacs. You have to install exactly a version
   ECB requires and also to make sure that the correct version is loaded
   into (X)Emacs!

   But ECB checks auto. during start-time if the correct versions of
   semantic and eieio are installed and gives you proper feedback.
   See Download required packages.

3. Add the new ECB-directory to your `load-path' variable.

   You *MUST* add the ECB-install-directory to the `load-path' either
   by changing the `load-path' variable directly in your `.emacs' or
   `site-lisp/site-start.el' or by working with a file `subdirs.el'.

   *ATTENTION*: ECB is NOT properly installed if it's directory is not
   added to `load-path' and for example just loaded by

      (load-file "/path/to/ecb/ecb.el")

   Do not do this!

4. Add to your `.emacs' or `site-lisp/site-start.el' the line:

      (require 'ecb)

5. Restart Emacs.

ECB is now ready for use and can be activated by calling `M-x
ecb-activate'. Now you can either starting using ECB or you can do
these optional installation steps:

6. Call `ecb-byte-compile'

   This byte compiles ECB. You can safely ignore all messages.  (You
   can also bytecompile ECB from the command-line either by using the
   `Makefile' or by using the batch-file `make.bat'. Just read the
   comments in that file you choose.)

7. Install the supplied `ecb.info'

   The ECB distribution contains a file `ecb.info' which is the
   online-help of ECB in Info-format. You can install this online help
   so it's available in the Top-directory of Info. There are two ways
   to do this:

    - Use "install-info" (recommended):

      1. Copy the file `ecb.info' into the info-directory of Emacs

      2. Install it with the command "install-info" (if available on
         your system) in the `dir'-file.

      The supplied `Makefile' offers a target `install-help' which does
      both of these steps. You have just to call `make install-help'
      with the correct EMACSINFOPATH set (see the comment in
      `Makefile'). Here is an example:

         make EMACSINFOPATH=/path/to/emacs/info install-help

    - Manual Installation:

      Copy the file `ecb.info' into the info-directory of Emacs and
      modify the file `dir' manually.

   But it doesn't matter if you do not execute this step (7.) because
   the online help of ECB is always available though, see
   `ecb-show-help' (see Interactive ECB commands).

First steps after activating ECB first time
===========================================

This section of the ECB online-help is displayed automatically by ECB
after activating ECB first time and describes what are the first basic
steps:

1. Configure where ECB can find your sources:

   Call `M-x customize-option RET ecb-source-path RET'(1). This lets
   you customize the option `ecb-source-path' with the
   customize-feature of Emacs. This opens a customize-buffer where you
   can insert all the directories where ECB can find your source-files.
   Save your changes with the button "Save for future sessions" and
   then throw away this customize-buffer either by killing it with `M-x
   kill-buffer' or clicking at the button "Finish".

2. Read the online-help of ECB:

   The online-help of ECB is available via

    - calling `M-x ecb-show-help',

    - pressing `C-c . o' or

    - using the menu "ECB".

   (The section you are currently reading is part of the online-help of
   ECB)

3. Start working with ECB.

---------- Footnotes ----------

(1) This means first hitting the keys `M' (Meta- or Alt-key) and `x'
simultaniously, inserting "customize-option" in the minibuffer, hitting
RETURN, inserting "ecb-source-path" in the minibuffer and finally
hitting RETURN again

Overview
********

ECB is a global minor-mode which offers a few "ECB-windows" for
browsing your sources comfortable with the mouse and the keyboard.
These "special" windows are also called "tree-buffer" in this manual.
Every "item" in such a tree-buffer, i.e. every line, is also called a
"node" of this tree-buffer. There are currently three different types
of ECB-windows/tree-buffers:

 - ECB-Directories

 - ECB-Sources

 - ECB-Methods

In addition to these "special" ECB-windows you have always one or two
"edit-windows" (see The edit-window) in the ECB-frame and at the
bottom a "compilation-window" (optional), where all the output of
Emacs-compilation (compile, grep etc.) is shown (see Temp- and compile-buffers).

The following "ascii-screenshot" illustrates the typical layout of the
ECB-frame(1):

   ------------------------------------------------------------------
   |              |                                                 |
   |  Directories |                                                 |
   |              |                                                 |
   |--------------|                                                 |
   |              |                                                 |
   |  Sources     |                                                 |
   |              |                                                 |
   |--------------|                 Edit-window(s)                  |
   |              |        (can be splitted in two windows)         |
   |  Methods     |                                                 |
   |              |                                                 |
   |--------------|                                                 |
   |              |                                                 |
   |  History     |                                                 |
   |              |                                                 |
   ------------------------------------------------------------------
   |                                                                |
   |                 Compilation-window (optional)                  |
   |                                                                |
   ------------------------------------------------------------------

In the following subsections the "special" ECB-windows will be
explained in detail.

---------- Footnotes ----------

(1) This is only one example of the layouts ECB offers, see Changing the ECB-layout

ECB Directories
===============

 * Select directories (and - if enabled - source files) in the
   "ECB-Directories" buffer by clicking a mouse button on the directory
   name or by hitting RETURN when the cursor is placed on the item line,
   see Usage of ECB.

 * Directory names with a "[+]" symbol after (or before) them can be
   expanded/collapsed by clicking on the symbol, pressing the TAB key
   when the cursor is placed on the package line or clicking a mouse
   button on the item, see Usage of ECB.

 * Right clicking on an item will open a popup menu where different
   operations on the item under the mouse cursor can be performed.

 * Pressing F2 will open the ECB customization group (see
   Customizing) in the edit window. F3 shows the online help in the
   edit-window. Pressing F4 in the ECB-directories buffer will offer
   adding a new source-path.

ECB Sources
===========

 * Source files can be selected by clicking a mouse button (see Using the mouse)
   or hitting RETURN (see Using the keyboard) on the
   source row in the "ECB-Sources" or "ECB- History" windows.

   IMPORTANT: If you hold down the SHIFT-key while clicking with the
   primary mouse button (see Using the mouse) or RETURN (see
   Using the keyboard) on a source row in the ECB-Sources or
   ECB-History windows then the source will not be displayed in the
   edit-window but it will be scanned in the background and all its
   contents (e.g. methods and variables) are listed in the "ECB
   Methods" window (see ECB Methods. So you can get an overlook over
   the source without changing the buffer in the edit-window.

 * Clicking on the source file with the secondary mouse button or
   C-RETURN (see Usage of ECB) will open the source file in the
   other edit window.

 * Right clicking on a source file will open a popup menu where
   different operation on the item under the mouse cursor can be
   performed.

ECB Methods
===========

 * The "ECB-Methods" buffer contains the methods (and variables, if you
   want) in the selected source file. When a method/variable is selected
   with the primary mouse button  or RETURN (see Usage of ECB) the
   edit buffer will jump to the method/variable.

 * Clicking on a method/variable with the secondary mouse button or
   C-RETURN (see Usage of ECB) will jump to the method in the other
   edit window.

Activation and Deactivation
***************************

This chapter describes all aspects of activating and deactivating ECB.

Standard activation and deactivation
====================================

Call `M-x ecb-activate' and `M-x ecb-deactivate' to activate or
deactivate ECB. If you want ECB started in a new frame see the option
`ecb-new-ecb-frame' (default is nil). `ecb-activate' always raises and
selects the ECB-frame even if ECB is already started.

Because ECB is a global minor-mode it can also be (de)activated/toggled
by `M-x ecb-minor-mode'.

Automatic activation and deactivation
=====================================

There are three options for auto. (de)activation ECB after Emacs-start
and also major-mode based.

`ecb-auto-activate'
   This option is for auto. activating ECB after Emacs-startup. Set this
   to not nil and ECB will automaticaly be started after Emacs comes up.

`ecb-major-modes-activate'
`ecb-major-modes-deactivate'
   These option give you the possibility to activate (rsp. deactivate)
   ECB on a major-mode basis, means you can define for which major-modes
   ECB should be activated and for which modes it should activated.

   If activating or deactivating is too strong you can also customize
   ECB with these two option only hiding/showing it's ECB-windows
   (tree-buffers) on a major-mode basis. At last this is nothing more
   than auto. calling `ecb-toggle-ecb-windows' (see Interactive ECB commands
   depending which major-mode is active.

Usage of ECB
************

This chapter describes in a detailed manner all aspects of using the
Emacs Code Browser.

Working with the mouse in the ECB-windows
=========================================

Normally you get best usage if you use ECB with a mouse. ECB
distinguishes between a "primary" and a "secondary" mouse-button:

A click with the primary button causes the main effect in each
ECB-buffer:

 - ECB Directories: Expanding/collapsing nodes and displaying files in
   the ECB-Sources buffer.

 - ECB sources/history: Opening the file in that edit-window specified
   by the option `ecb-primary-mouse-jump-destination'.

 - ECB Methods: Jumping to the method in that edit-window specified by
   the option `ecb-primary-mouse-jump-destination'.

Per default the complete node-name of an item in a tree-buffer is
displayed in the echo-area if the mouse moves over it, regardless if
the related window is the active one or not. You can get the same
effect if you click with the primary mouse-button onto a node while
SHIFT is held. In general: Via `ecb-show-node-info-in-minibuffer' you
can specify in a detailled manner for every ECB tree-buffer when and
which node-info should be displayed in the minibuffer.

IMPORTANT: Doing this SHIFT-click in the ECB-Sources or ECB-History
windows does not only show the node in the echo-area but it also opens
the clicked source only in the background and shows all its
methods/variables in ECB-Methods; the buffer of the edit-window is not
changed! This is very useful to get only an overlook for a certain
source.

The secondary mouse-button is for opening (jumping to) the file in the
other window (see the documentation
`ecb-primary-mouse-jump-destination').

With the option `ecb-primary-secondary-mouse-buttons' the following
combinations of primary and secondary mouse-buttons are possible:

 - primary: mouse-2, secondary: C-mouse-2(1). This is the default.

 - primary: mouse-1, secondary: C-mouse-1

 - primary: mouse-1, secondary: mouse-2

If you change this during ECB is activated you must deactivate and
activate ECB again to take effect

In each ECB-buffer mouse-3 (= right button) opens a special context
popup-menu for the clicked item where you can choose several senseful
actions.

---------- Footnotes ----------

(1) means mouse-2 while CTRL-key is pressed.

Working with the keyboard in the ECB-windows
============================================

ECB offers the `ecb-mode-map' which binds the most important functions
of ECB to keys so you can easily use ECB without a mouse.

IMPORTANT: Do not modify `ecb-mode-map' directly! The option
`ecb-key-map' defines all ECB keybindings, including a common prefixkey
(This is by default `C-c .'). If there are conflicts with other
minor-modes or packages you can define very easy another prefix. Please
read carefully the description of `ecb-key-map' (see ecb-general).!

Navigation
----------

In the ECB-buffers RETURN and TAB are the most important keys:

 * RETURN does the same as the primary button and C-RETURN does the same
   as the secondary button. The terms primary and secondary are
   explained in Using the mouse. S-RETURN is the same as the
   SHIFT-click (see ECB Sources). See also the option
   `ecb-tree-RET-selects-edit-window' and the function
   `ecb-toggle-RET-selects-edit-window' which is bound to `C-t' in each
   tree-buffer of ECB!

 * TAB always expands or collapses expandable nodes.

The RETURN and TAB keys can not be (re)defined with `ecb-key-map'!

If you set `ecb-tree-navigation-by-arrow' to not nil then the left- and
right-arrow keys work in the ECB tree-window in the following smart way
if onto an expandable node:

 * Left-arrow: If node is expanded then it will be collapsed otherwise
   point jumps to the next "higher" node in the hierarchical tree
   (higher means the next higher level or - if no higher level
   available - the next higher node on the same level).

 * Right-arrow: If node is not expanded then it will be expanded.

Onto a not expandable node the horizontal arrow-keys go one character
in the senseful correct direction.

Incremental search for a node in current tree-buffer
----------------------------------------------------

Each displayable key (e.g. all keys normally bound to
`self-insert-command') is appended to the current seach-pattern. The
tree-buffer tries to jump to the first node which matching the current
search-pattern either as substring or as prefix (see below). If no
match is found then nothing is done. There are some special keys:

 * `backspace' and `delete': Delete the last character from the
   search-pattern.

 * `home': Delete the complete search-pattern

 * `end': Expand either to a complete node if current search-pattern is
   already unique or expands to the greates common substring or prefix
   of the nodes. If there are at least two nodes with the same greatest
   common-prefix than every hit of `end' jumps to the next node with
   this common prefix.

For better overlooking the current search-pattern is shown in the echo
area.  After selecting a node with RET the search-pattern is cleared
out. With `ecb-tree-incremental-search' you can specify if the current
search-pattern must be a real prefix of the node (default) or if any
substring is matched.

For faster and easier finding the right node in a ecb-window thi
incremental search ignores the following non interesting stuff:

 - any leading spaces

 - expand/collapse-buttons: [+] resp. [-]

 - protection-signs (+, -, #) in the method-window if uml-notation is
   used

 - variables types or returntypes in front of variable- or method-names.

 - const specifier for variables

This means: Just type in the prefix (resp. a substring) of a class-,
variable-, method-, directory- or filename and ECB will bring you as
fast as possible to the node you want. Incremental node-search uses the
value of `case-fold-search'.

Tip: The `ecb-minor-mode' offers you in the `ecb-mode-map'
(customizable via `ecb-key-map') some keys for selecting every window
of the ecb-frame. This makes window-selection a child´s play. For
example you can jump into the method-window by hitting `C-c . m'.

Working with the edit-window
============================

ECB offers you all what you need to work with the edit-window as if the
edit-window would be the only window of the ECB-frame.

ECB offers you to advice the following functions so they work best with
ECB:

 - `other-window'

 - `delete-window'

 - `delete-other-windows'

 - `split-window-horizontally'

 - `split-window-vertically'

 - `switch-to-buffer'

 - `switch-to-buffer-other-window'

 - `other-window-for-scrolling'

The behavior of the adviced functions is:

 * All these adviced functions behaves exactly like their corresponding
   original functons but they always act as if the edit-window(s) of ECB
   would be the only window(s) of the ECB-frame. So the edit-window(s)
   of ECB seems to be a normal Emacs-frame to the user.

 * If called in a not edit-window of ECB all these function jumps first
   to the (first) edit-window, so you can never destroy the ECB-window
   layout unintentionally.

 * If called in another frame than the ECB-frame these functions behave
   exactly like the not adviced original versions!

ATTENTION: If you want to work within the edit-window with splitting
and unsplitting the edit-window(s) it is highly recommended to use the
adviced-functions of ECB instead of the original Emacs-functions (see
above). Per default ECB does advice all of the functions mentioned
above but with the option `ecb-advice-window-functions' you can
customizes which functions should be adviced by ECB. Please read
carefully the documentation of this option!

Another interesting option in the context of the edit-window and these
adviced functions is `ecb-layout-always-operate-in-edit-window'!

Temp- and compile-buffers display in ECB
========================================

If you call any help in Emacs, e.g. by calling `describe-function', or
if you do a completion in the minibuffer, then Emacs displays the
result-buffer in another window. This behavior you have also in ECB.
If the edit-window is already splitted then the temp-buffer is
displayed in the "other" edit-window otherwise the edit-window will be
splitted first. The variables `temp-buffer-max-height' and
`temp-buffer-resize-mode' work also correctly with ECB.

Same for all compilation output-buffers (e.g. after a `compile' or
`grep') and the variable `compilation-window-height'.

This is default behavior of ECB. But there is also another way to
display such buffers:

 * With the option `ecb-compile-window-height' you can define if the ECB
   layout should contain per default a compilation-window at the bottom
   (and if yes the height of it). If yes ECB displays all output of
   compilation-mode (compile, grep etc.) in this special window. Same
   for displaying help-buffers or similar stuff.

 * With the option `ecb-compile-window-temporally-enlarge' you can allow
   Emacs to enlarge temporally the ECB-compile-window in some
   situations.  Please read the comment of this option. See also the
   description of the function `ecb-toggle-enlarged-compilation-window'.

 * With the option `ecb-layout-switch-to-compilation-window' you can
   modify the switch-to-buffer...-functions to work best if your layout
   contains a compilation-window. See the docstring of this option.

 * With the command `ecb-cycle-through-compilation-buffers' (see
   Interactive ECB commands) you can cycle through all current open
   compilation-buffers in the sense of `ecb-compilation-buffer-p' very
   fast.

But because ECB works best without such a durable compilation-window
you should read the documentation of these two options carefully!

Using and customizing the ECB-Methods buffer
============================================

This chapter describes how to use and customize the Methods-buffer of
ECB.

Customizing the display of the Methods-buffer
---------------------------------------------

The ECB-Methods buffer is probably the most important browsing window
offered by ECB. It displays all semantic informations of the current
buffer in the edit-window.

ECB gets all informations displayed in this Methods-buffer from the
semantic-library. This library parses auto. the current source-buffer
in the edit-window of ECB and returns all information in form of
"tokens" to ECB which displays them in a browsable form in its
Method-buffer. See ECB Methods for information how to use the
Methods-buffer.

There are several options to customize which tokens ECB should display
in general, if the tokens should be collapsed or expanded, how to
fontify them (i.e. syntax-highlighting) and something more.

`ecb-show-tokens'
   Which semantic-tokens (e.g. types, methods, variables etc.) should be
   displayed and should they be collapsed, flattened or expanded.
   Sorting is also possible.

`ecb-font-lock-tokens'
`ecb-type-token-display'
   How to fontify the tokens in the Method-buffer

`ecb-token-display-function'
   ECB and semantic offer several predefined functions for displaying
   the tokens. Here you can customize, what informations tokens should
   contain (only the method-name or the whole signature or something
   else) and what notation should be used, e.g. UML or not.

These are the most important options for this topic but it is
recommended to have a look into the customize-group `ecb-methods'
(see ecb-methods) and check all the options offered there!

Rebuilding the Methods-buffer
-----------------------------

In almost all cases there is *NO* need to manually rebuild the
method-buffer, because it is always done automatically if necessary.
But nevertheless there exist a few rare scenarios where a complete
manual rebuild can be necessary. Here is one example:

Depending on the semantic-version: If an elisp-file is parsed which
contains a defun X in the middle where the closing ) is missing, then
semantic parses only until this defun X is reached and you will get an
incomplete ECB-method buffer. In such a case you must complete the
defun X and then completely reparse the elisp-file and rebuild the ECB
method buffer!

A complete manually rebuild is done by `ecb-rebuild-methods-buffer'.

Changing, customizing and redrawing the ECB-layout
==================================================

The term "ECB-layout" means in which windows the ECB-frame is divided.
This chapter describes all aspects concerning this layout, especially
changing, customizing and redrawing it.

Changing and customizing the ECB-layout
---------------------------------------

ECB offers several predefined layouts with different sets and also
different locations of ECB-windows. To see which layouts are available
and choose an appropriate one just customize the option
`ecb-layout-nr'. The docstring of this option explains how to see the
different available layouts.

If you want to switch fast between some layouts see the option
`ecb-toggle-layout-sequence' and the command `ecb-toggle-layout' (see
Simulating speedbar)

In addition to the general layout you can specify if the layout should
contain a durable compilation-window at the bottom of the frame, see
`ecb-compile-window-height' (see Temp- and compile-buffers).

Maybe you want also change the look&feel of the tree-buffers. Then you
can change the location of the collapse- and expand-symbols and the
indendation of sub-nodes in a tree. See `ecb-tree-indent' and
`ecb-tree-expand-symbol-before'.

Redrawing the ECB-layout
------------------------

If you have unintenionally destroyed the ECB-layout, you can always
restore the layout with calling `ecb-redraw-layout'. This is even true,
if you get messages like "wrong-type-argument window-live-p #<window
222>".

If the variable `ecb-redraw-layout-quickly' is not nil then the redraw
is done by the `ecb-redraw-layout-quickly' function, otherwise by
`ecb-redraw-layout-full'. But it's strongly recommended to use the
quick redraw only if you have really slow machines where a full redraw
takes several seconds because the quick redraw is not really safe and
may have some drawbacks! On normal machines the full redraw should be
done in << 1s!

Hiding/Showing the ECB windows
==============================

With `ecb-toggle-ecb-windows' you can hide/show all the ECB windows
without changing the activation state of ECB and also without
deactivating the advices for `delete-other-windows' and/or
`delete-window'. This is most useful if you use a layout like nr.10
(see Tips and tricks) or if you want to have maximum space for
editing and you don't need the browsing windows all the time.

Back- and forward navigation like a browser
===========================================

With ECB you can "browse" in your source-files like with a web-browser.
This means ECB stores the current buffer- and window-position relative
to the current token(1) in the edit-window after

 - selecting a token in the ECB-methods buffer or

 - selecting a source-file in the ECB-sources/history-buffer.

ECB offers two commands `ecb-nav-goto-next' (`C-c . n') and
`ecb-nav-goto-previous' (`C-c . p') to go forward and backward within
this navigation historylist. These commands are also available via the
menu "ECB -> Navigate".

Aside normal "location-browsing" this is usefull for example in a
scenario where `ecb-token-jump-narrow' is activated:

1. You edit a function

2. Goto another function above the current in the same file

3. Add a few lines

4. Call ecb-nav-goto-previous

   Now you will edit at the same place in the function.

---------- Footnotes ----------

(1) e.g. a method, a variable or any other semantic token

Synchronization of the ECB-windows
==================================

Per default ECB synchronizes automatically the contents of the
ECB-windows/tree-buffers with the current active edit-window (rsp. the
current buffer of the edit window):

 * ECB-directories:

   This windows is synchronized to display the directory where the
   source-file which is displayed in the edit-window is located. If the
   source-path (i.e. an element of the option `ecb-source-path')
   containing this directory is not expanded it will be auto. expanded
   according to the value of the option
   `ecb-auto-expand-directory-tree' (see ecb-directories).

 * ECB-sources:

   The ECB-sources-buffer contains after synchronizing all the sources
   of the directory of the "current" source-file displayed in the
   edit-window. The entry of the "current" source-file is highlighted.

 * ECB-methods:

   Contains after synchronizing all the tokens of the buffer in the
   edit-window, i.e. all methods, variables etc... depending of the
   major-mode.

 * ECB-history:

   Highlights the entry of the buffer displayed in the edit-window if
   this buffer is a source-file.

This feature can be customized with the option `ecb-window-sync':

If active then the synchronization takes place always a buffer changes
in the edit window, if deactivated then never. But you can also set
this option to a list of major-modes and then the sync. will only be
done if the major-mode of the current buffer belongs NOT to this list.

But in every case the synchronization takes only place if the
major-mode of the current-buffer in the edit-window has a relation to
files or directories. Examples for the former one are all
programming-language-modes like `c++-mode' or `java-mode', `Info-mode'
too, an example for the latter one is `dired-mode'. For all major-modes
related to non-file/directory-buffers like `help-mode',
`customize-mode' and others never a synchronization will be done!

It's recommended to exclude at least `Info-mode' because it makes no
sense to synchronize the ECB-windows after calling the Info help.  Per
default also `dired-mode' is excluded but it can also making sense to
synchronize the ECB-directories/sources windows with the current
directory of the dired-buffer in the edit-window.

*NOTE*: With the command `ecb-current-buffer-sync' you can do a
manually synchronization if the automatic one is switched off or if you
just want to do this!

Interactive ECB commands
========================

ECB offers the a lot of interactive commands. Some of these commands
prompt the user in the minibuffer if called with a prefix argument.

Example: If `ecb-clear-history' is called with a prefix argument then
you will be prompted in the minibuffer with:

   Clear from history: [all, not-existing-buffers, existing-buffers]

You can choose one of the options enclosed in brackets with
TAB-completion; hitting RET direct after the prompt chooses auto. the
first offered option (in the example above "all").

These are the interactive commands of ECB (listed in alphabetical
order):

 - Command: ecb-activate
   Activates the ECB and creates all the buffers and draws the
   ECB-screen with the actually choosen layout (see `ecb-layout-nr').
   This function raises always the ECB-frame if called from another
   frame. This is the same as calling `ecb-minor-mode' with a positive
   argument.

 - Command: ecb-add-all-buffers-to-history
   Add all current file-buffers to the history-buffer of ECB.

 - Command: ecb-clear-history &optional clearall
   Clears the ECB history-buffer. If CLEARALL is `nil' then the
   behavior is defined in the option `ecb-clear-history-behavior'
   otherwise the user is prompted what buffers should be cleared from
   the history-buffer. For further explanation see
   `ecb-clear-history-behavior'.

 - Command: ecb-current-buffer-sync &optional force
   Synchronizes the ECB buffers with the current buffer. Unless FORCE
   is non-`nil' then do this only if current-buffer differs from the
   source displayed in the ECB tree-buffers.

 - Command: ecb-cycle-through-compilation-buffers &optional
      choose-buffer
   Cycle through all compilation buffers currently open and display them
   within the compilation window `ecb-compile-window'. If the currently
   opened buffer within the compilation window is not a compilation
   buffer, we jump to the first compilation buffer. If not we try to
   loop through all compilation buffers. If we hit the end we go back
   to the beginning.

   If CHOOSE-BUFFER is not `nil' then the user will be prompted for the
   compilation-buffer to swtich to.

   See also the option `ecb-layout-switch-to-compilation-window'!  The
   difference is that this cycling-function offers only
   compilation-buffers in the sense of `ecb-compilation-buffer-p'
   whereas the adviced version of `switch-to-buffer' offers any buffer
   but switches to `ecb-compile-window' if a compilation-buffer!

 - Command: ecb-deactivate
   Deactivates the ECB and kills all ECB buffers and windows.

 - Command: ecb-display-upgraded-options
   Display a message-buffer which options have been upgraded or reset.

 - Command: ecb-download-ecb
   Download ECB from the ECB-website and install it. For this the
   options `ecb-download-url' and `ecb-download-version' must be set
   correct, whereas the default value of the former one should always be
   correct.

   For details about downloading and what requirements must be satisfied
   see Downloading new versions!

   After sucessfull downloading the new ECB will be installed in a
   directory parallel to current ECB-directory. After adding this new
   directory tp `load-path' and restarting Emacs the new ECB version can
   be activated by `ecb-activate'.

 - Command: ecb-goto-window-compilation
   Goto the ecb compilation window `ecb-compile-window'.

 - Command: ecb-goto-window-directories
   Make the ECB-directories window the current window.

 - Command: ecb-goto-window-edit1
   Make the (first) edit-window window the current window.

 - Command: ecb-goto-window-edit2
   Make the second edit-window (if available) window the current window.

 - Command: ecb-goto-window-history
   Make the ECB-history window the current window.

 - Command: ecb-goto-window-methods
   Make the ECB-methods window the current window.

 - Command: ecb-goto-window-sources
   Make the ECB-sources window the current window.

 - Command: ecb-minor-mode &optional arg
   Toggle ECB minor mode. With prefix argument ARG, turn on if
   positive, otherwise off. Return non-`nil' if the minor mode is
   enabled.

 - Command: ecb-nav-goto-previous
   Go backward in the navigation historylist, see Back/forward navigation.

 - Command: ecb-nav-goto-next
   Go forward in the navigation historylist, see Back/forward navigation.

 - Command: ecb-rebuild-methods-buffer
   Updates the methods buffer with the current buffer after deleting the
   complete previous parser-information, means no semantic-cache is
   used!  Point must stay in an edit-window otherwise nothing is done.
   This method is merely needed if semantic parses not the whole buffer
   because it reaches a not parsable code. Examples when a call to this
   function is necessary:

   If an elisp-file is parsed which contains in the middle a defun X
   where the closing ) is missing then semantic parses only until this
   defun X is reached and you will get an incomplete ECB-method buffer.
   In such a case you must complete the defun X and then call this
   function to completely reparse the elisp-file and rebuild the ECB
   method buffer!

   If you change only the name of a method or a variable and you want
   the new name be shown immediately in the ECB-method buffer then you
   must call this function.

 - Command: ecb-redraw-layout
   Redraw the ECB screen. If the variable `ecb-redraw-layout-quickly' is
   not nil then the redraw is done by the `ecb-redraw-layout-quickly'
   function, otherwise by `ecb-redraw-layout-full'. But it's strongly
   recommended to use the quick redraw only if you have really slow
   machines where a full redraw takes several seconds because the quick
   redraw is not really safe and may have some drawbacks! On normal
   machines the full drawback should be done in << 1s!

 - Command: ecb-show-help &optional format
   Shows the online help of ECB either in Info or in HTML format
   depending of the value of `ecb-show-help-format'. If called with
   prefix argument, i.e. if FORMAT is not nil then the user is prompted
   to choose the format of the help (Info or HTML).

 - Command: ecb-submit-problem-report
   Submit a problem report for the ECB to the ECB mailing-list. This
   command generates in the edit-window a problem-report which contains
   already the current values of all ECB options, the current
   backtrace-buffer if there is any and the current message-buffer. You
   will be asked for a problem-report subject and then you must insert a
   description of the problem. Please describe the problem as detailed
   as possible!

 - Command: ecb-toggle-ecb-windows &optional arg
   Toggle visibilty of the ECB-windows. With prefix argument ARG, make
   visible if positive, otherwise invisible. This has nothing to do
   with (de)activating ECB but only affects the visibility of the ECB
   windows. ECB minor mode remains active!

 - Command: ecb-toggle-enlarged-compilation-window &optional arg
   Toggle whether the `ecb-compile-window' is enlarged or not. If ARG >
   0 then enlarge to a sensefull value (see below), if ARG <= 0 then
   shrink `ecb-compile-window' to `ecb-compile-window-height' and if
   ARG is nil then toggle the enlarge-state.

   The `ecb-compile-window' is enlarged to the following value: At least
   to the value of `ecb-compile-window-height' and max. to half of the
   frame-height of the ECB-frame, best depending on the values of
   `compilation-window-height' (before ECB was started!) and the number
   of lines of current buffer in `ecb-compile-window'. If
   `compilation-window-height' is set before ECB was started then ECB
   never enlarges the `ecb-compile-window' over the value of
   `compilation-window-height'! Changing this option during activated
   ECB takes first effect after restarting ECB!

 - Command: ecb-toggle-layout
   Toggles between the layouts defined in `ecb-toggle-layout-sequence'.
   Note: This function works by changing the options `ecb-layout-nr' and
   `ecb-show-sources-in-directories-buffer' but only for current
   Emacs-session.

 - Command: ecb-update-directories-buffer
   Updates the ECB directories buffer.

 - Command: ecb-upgrade-options
   Check for all ECB-options if their current value is compatible to the
   defined type. If not upgrade it to the new type or reset it to the
   default-value of current ECB. Try also to upgrade renamed options.
   Displays all upgraded or reset options with their old (before the
   upgrade/reset) and new values.

Most of these functions are also available via the menu "ECB" and also
via the ECB keymap with prefix `C-c .' (see `ecb-minor-mode' for a
complete list of the keybindings).

Customizing ECB
***************

This chapter describes how to customize ECB for your personal taste.
The first chapter gives an overview of the most important options and
the second one lists all options of ECB.

*ATTENTION*: The best way you customize all the options of ECB is via
the customize-feature of (X)Emacs, i.e. means calling the commands
`customize-option' or `customize-group' etc. This is also the strongly
recommended way!

But of course you can also use `setq' or some elisp-code to change the
values of many but not all of the options. The values of the following
options *MUST NOT* be changed via `setq' or elisp-code but only with
the customize-feature!

 - `ecb-source-path'

 - `ecb-tree-RET-selects-edit-window'

 - `ecb-font-lock-tokens'

 - `ecb-bucket-token-display'

 - `ecb-token-display-function'

 - `ecb-type-token-display'

 - `ecb-show-tokens'

 - `ecb-exclude-parents-regexp'

 - `ecb-highlight-token-with-point-delay'

 - `ecb-window-sync-delay'

 - `ecb-show-node-info-in-minibuffer'

 - `ecb-key-map'

 - `ecb-layout-nr'

 - `ecb-compile-window-height'

 - `ecb-compile-window-temporally-enlarge'

 - `ecb-windows-width'

 - `ecb-windows-height'

 - `ecb-advice-window-functions'

 - `ecb-layout-window-sizes'

 - `ecb-mode-line-prefixes'

The most important options of ECB
=================================

Here are the most important options (it is recommended to check at
least the following options before working with ECB):

`ecb-source-path'
   Where ECB can find your sources. You must set this option!

`ecb-show-help-format'
   Should the online help of ECB be displayed in the standard Info
   format or in HTML format in a web-browser.

`ecb-auto-activate'
`ecb-major-modes-activate'
`ecb-major-modes-deactivate'
   Auto. (de)activation of ECB

`ecb-key-map'
   All ECB-keybindings incl. a common prefixkey (see Using the keyboard).

`ecb-new-ecb-frame'
   Should ECB create a new frame at activation time.

`ecb-primary-secondary-mouse-buttons'
`ecb-primary-mouse-jump-destination'
   Define how to use the mouse (see Using the mouse).

`ecb-tree-expand-symbol-before'
`ecb-tree-indent'
   The look&feel of the trees in the tree-buffers. Maybe you like a
   value of 4 for the latter one if you display the expand-symbol before
   (see Changing the ECB-layout).

`ecb-source-file-regexps'
   Which files will (not) be shown in ECB.

`ecb-show-node-info-in-minibuffer'
   When and which node-info should be displayed in the minibuffer?

`ecb-layout-nr'
   The ECB layout, means which windows you want to be displayed in the
   ECB-frame and also the location of these windows (see Changing the ECB-layout).

`ecb-token-display-function'
`ecb-type-token-display'
`ecb-show-tokens'
   How to display the entries in the ECB-method window (see
   Customizing the display).

But to make ECB working best for you it is also recommened to have a
look at Customizable options!

All customizable options of ECB
===============================

All customization of ECB is divided into the following "customize
groups". You can highly customize all the ECB behavior/layout so just
go to these groups and you will see all well documented ECB-options.

Group ecb-general
-----------------

This group contains the following options:

 - User Option: ecb-activate-before-layout-draw-hook
   Normal hook run at the end of activating the ecb-package by running
   `ecb-activate'. This hooks are run after all the internal setup
   process but directly before(!) drawing the layout specified in
   `ecb-layout' (means before dividing the frame into several windows).

   A senseful using of this hook can be maximizing the Emacs-frame for
   example, because this should be done before the layout is drawn
   because ECB computes the size of the ECB-windows with the current
   frame size! If you need a hook-option for the real end of the
   activating process (i.e. after the layout-drawing) look at
   `ecb-activate-hook'.

 - User Option: ecb-activate-hook
   Normal hook run at the end of activating the ecb-package by running
   `ecb-activate'. This hooks are run at the real end of the activating
   process, means after the layout has been drawn!. If you need hooks
   which are run direct before the layout-drawing look at
   `ecb-activate-before-layout-draw-hook'.

 - User Option: ecb-auto-activate
   Automatically startup ECB when Emacs starts up. This should only be
   true if you always want to run `ecb-activate'.

 - User Option: ecb-auto-compatibility-check
   Check at ECB-startup if all ECB-options have correct values. If not
   nil then all ECB-options are checked if their current value have the
   correct type. It the type is incorrect the option is either auto.
   upgraded to the new type or reset to the default-value of current ECB
   if no upgrade is possible. This feature can also upgrade options
   which are renamed in current ECB and try to transform the old-value
   to the new named option. After startup all upgraded or reset options
   are displayed with their old (before upgrade/reset) and new values.
   See also the commands `ecb-upgrade-options' and
   `ecb-display-upgraded-options'. If this option is off then the user
   can perform the check and reset manually with `ecb-upgrade-options'.
   See Auto. option-upgrading.

 - User Option: ecb-current-buffer-sync-hook
   Normal hook run at the end of `ecb-current-buffer-sync'.

 - User Option: ecb-deactivate-hook
   Normal hook run at the end of deactivating (but before the ecb-layout
   is cleared!) ECB by running `ecb-deactivate'.

 - User Option: ecb-debug-mode
   If not nil ECB displays debug-information in the Messages-buffer.
   This is done for some critical situations concerning semantic-tokens
   and their overlays (or extends for XEmacs). Normally you should not
   need this switched on! But if you get errors like "destroyed extend"
   for XEmacs or "wrong-argument-type" concerning overlays for GNU
   Emacs then you should switch on this option and submitting a
   bug-report to the ecb-mailing-list (`ecb-submit-problem-report')
   after getting the error again!

 - User Option: ecb-key-map
   Specifies all keybindings for the ECB minor-mode keymap. The value is
   a cons-cell where the car is a common-prefix key for all the
   keybindings. The cdr is a list of keybindings each of them a list
   again. A keybinding has the following form:

      '(<common-prefix-flag> <keysequence> <function>) where

  `<common-prefix-flag>'
      If t then the common-prefixkey defined as car of the value (see
      above) is used.

  `<keysequence>'
      If the common prefixkey is used then the final keybinding is the
      concatenation of the common-prefixkey (see above) and this
      keysequence.

  `<function>:'
      The function to bind to the key. This can also be a
      lambda-expression .

   It is highly recommended to use one of the standard keys C-c or C-x
   as first key of your common-prefixkey!

   You MUST change this option via customize to take effect!

   All keysequences must be inserted as a string and must follow the
   syntax needed by `read-kbd-macro' or `kbd'. This means you can
   insert the key in the same manner `C-h k' displays keysequences.
   Here is the summary of the syntax:

   Text is divided into "words" separated by whitespace. Except for the
   words described below, the characters of each word go directly as
   characters of the keysequence. The whitespace that separates words
   is ignored. Whitespace in the macro must be written explicitly, as
   in `C-c SPC'.

    * The special words RET, SPC, TAB, DEL, LFD, ESC, and NUL represent
      special control characters. The words must be written in
      uppercase.

    * A word in angle brackets, e.g., <return>, <down>, <left> or <f1>,
      represents a function key. (Note that in the standard
      configuration, the function key <return> and the control key RET
      are synonymous.).  You can use angle brackets on the words RET,
      SPC, etc., but they are not required there.

    * Keys can be written by their ASCII code, using a backslash
      followed by up to six octal digits. This is the only way to
      represent keys with codes above ÿ.

    * One or more prefixes M- (meta), C- (control), S- (shift), A-
      (alt), H- (hyper), and s- (super) may precede a character or key
      notation. For function keys, the prefixes may go inside or
      outside of the brackets: C-<down> = <C-down>. The prefixes may be
      written in any order: M-C-x = C-M-x. Prefixes are not allowed on
      multi-key words, e.g., C-abc, except that the Meta prefix is
      allowed on a sequence of digits and optional minus sign: M-123 =
      M- M-1 M-2 M-3.

    * The `^' notation for control characters also works: ^M = C-m.

 - User Option: ecb-major-modes-activate
   List of major-modes for which ECB shoulb be activated or shown. Do
   not mistake this option with `ecb-auto-activate'. The latter one is
   for activating ECB after Emacs-startup (even without opening a
   buffer) and this one is for defining for which major-modes ECB
   should be activated if the mode goes active!

   The behaviour is like follows: If a mode is contained in this option
   ECB is activated after activating this mode (if ECB was deactivated
   before) or the ECB-windows are shown if ECB was already active but
   its windows were hidden. In every case ECB is activated with visible
   ECB-windows afterwards!

   For every major mode there can be specified an `ecb-layout-nr':

    - `default': The value customized with `ecb-layout-nr' is choosen.

    - an integer: ECB is activated with this layout-nr. This changes
      the value of `ecb-layout-nr' but only for current emacs-session!
      But the layout is only changed if ECB was activated, if just the
      ECB-windows were shown, the current layout is used!

   There are two additional options:

    - `none': No major-modes should activate ECB automatically.

    - a regexp: This means all major-modes which are not listed in
      `ecb-major-modes-deactivate' activate ECB except the symbol-name
      of `major-mode' matches this regexp. If this option is set then
      the default regexp excludes all Info- and customize-buffers
      because this buffers should not change anything in the
      ECB-activation state.

   Any auto. activation is only done if the current-frame is unsplitted
   to avoid changing unnecessarily or unintentionally the frame-layout
   if the user just jumps between different windows.

 - User Option: ecb-major-modes-deactivate
   List of major-modes for which ECB should be deactivated or hidden.
   Specify if ECB should be deactivated or at least hidden if a
   major-mode is active. For each major-mode there must be added an
   action what should be done:

    - `hide': ECB just hides all the ECB windows like with
      `ecb-hide-ecb-windows'.

    - `deactivate': ECB is completely deactivated after activating the
      major-mode.

   There are two additional options:

    * `none': No major-modes should deactivate/hide ECB automatically.

    * A cons for the meaning "All except the activated modes of
      `ecb-major-modes-activate'". The car of this cons can be:

       - `hide-all-except-activated': All major-modes which are not
         listed in `ecb-major-modes-activate' hide the ECB-windows.

       - `deactivate-all-except-activated': All major-modes which are
         not listed in `ecb-major-modes-activate' deactivate ECB.

      The cdr of this cons is a regexp: This means all major-modes
      which are not listed in `ecb-major-modes-activate'
      deactivate/hide ECB except the symbol-name of `major-mode'
      matches this regexp. If this option is set then the default
      regexp excludes all Info- and customize-buffers because this
      buffers should not change anything in the ECB-activation state.

   If a major-mode is listed in `ecb-major-modes-activate' as well as
   in `ecb-major-modes-deactivate' then ECB is activated!

   Any auto. deactivation/hiding is only done if the edit-window of ECB
   is unsplitted and point is in the edit-window to avoid changing
   unnecessarily or unintentionally the frame-layout if the user just
   jumps between different edit-windows, the tree-windows and the
   compile-window of ECB.

 - User Option: ecb-minor-mode-text
   String to display in the mode line when ECB minor mode is active.
   (When the string is not empty, make sure that it has a leading
   space.)

 - User Option: ecb-mode-line-prefixes
   Prefixes shown in the modelines of the ECB buffers. The displayed
   prefix then looks like: "[ <PREFIX>[: ]]", means if a prefix is
   defined for an ECB buffer then a single space is prepended and if
   there is additional text to display (e.g. the current directory in
   the sources buffer) then also the string ": " is appended.

 - User Option: ecb-primary-mouse-jump-destination
   Jump-destination of a primary mouse-button click (see
   `ecb-primary-secondary-mouse-buttons') in an ECB-window, if you
   click onto a source or method or variable. Defines in which
   edit-window (if splitted) ECB does the "right" action (opening the
   source, jumping to a method/variable). There are two possible
   choices:

    - `left-top': Does the "right" action always in the left/topmost
      edit-window.

    - `last-point': Does the "right" action always in that edit-window
      which had the point before.

   If the edit-window is not splitted this setting doesn't matter.

   Note: A click with the secondary mouse-button (see again
   `ecb-primary-secondary-mouse-buttons' does the "right" action always
   in the "other" window related to the setting in this option.

 - User Option: ecb-primary-secondary-mouse-buttons
   Primary- and secondary mouse button for using the ECB-buffers. A
   click with the primary button causes the main effect in each
   ECB-buffer:

    * ECB Directories: Expanding/collapsing nodes and displaying files
      in the ECB Sources buffer.

    * ECB sources/history: Opening the file in that edit-window
      specified by the option `ecb-primary-mouse-jump-destination'.

    * ECB Methods: Jumping to the method in that edit-window specified
      by the option `ecb-primary-mouse-jump-destination'.

   A click with the primary mouse-button while the SHIFT-key is pressed
   only displays the complete clicked node in the minibuffer. This is
   useful if the node is longer as the window-width of the ECB-window
   and `ecb-truncate-lines' is not nil.

   The secondary mouse-button is for opening (jumping to) the file in
   the other window (see the documentation
   `ecb-primary-mouse-jump-destination').

   The following combinations are possible:

    - primary: mouse-2, secondary: C-mouse-2 (means mouse-2 while
      CTRL-key is pressed). This is the default setting.

    - primary: mouse-1, secondary: C-mouse-1

    - primary: mouse-1, secondary: mouse-2

   If you change this during ECB is activated you must deactivate and
   activate ECB again to take effect

 - User Option: ecb-show-help-format
   The format `ecb-show-help' shows its online help. Allowed values are
   'info (for the Info format) and 'html (for HTML format). If the
   value is 'html then `browse-url-browser-function' says which browser
   is used.

 - User Option: ecb-show-node-info-in-minibuffer
   Define which node info should displayed in a tree-buffer after mouse
   moving over the node or after a shift click onto the node.

   For every tree-buffer you can define "when" node info should be
   displayed:

    - `always': Node info is displayed by moving with the mouse over a
      node.

    - `if-too-long': Node info is only displayed by moving with the
      mouse over a node does not fit into the window-width of the
      tree-buffer window. In the ECB directories buffer this means also
      if a node is shortend or if the node has an alias (see
      `ecb-source-path').

    - `shift-click': Node info is only displayed after a shift click
      with the primary mouse button onto the node.

    - `never': Node info is never displayed.

   For every tree-buffer you can define what info should be displayed:

    * Directory-buffer:
       - `name': Only the full node-name is displayed.

       - `path': The full-path of the node is displayed.

    * Sources-buffer:
       - `name': Only the full node-name is displayed.

       - `file-info': File infos for this file are displayed.

       - `file-info-full': Fill infos incl. full path for this file are
         displayed.

    * History-buffer: see Directories-buffer.

    * Methods-buffer:
       - `name': Only the full node name is displayed.

       - `name+type': The full name + the type of the node (function,
         class, variable) is displayed.

   Do NOT set this option directly via setq but use always customize!

 - User Option: ecb-temp-dir
   Specify a directory where ECB can store temporary files.

 - User Option: ecb-tree-RET-selects-edit-window
   In which tree-buffers RET should finally select an edit-window. If a
   name of an ECB tree-buffer is contained in this list then hitting RET
   in this tree-buffer selects as last action the right edit-window
   otherwise only the right action is performed (opening a new source,
   selecting a method etc.) but point stays in the tree-buffer.

   A special remark for the `ecb-directories-buffer-name': Of course
   here the edit-window is only selected if
   `ecb-show-sources-in-directories-buffer' is not nil (otherwise this
   would not make any sense)!

   The setting in this option is only the default for each tree-buffer.
   With `ecb-toggle-RET-selects-edit-window' the behavior of RET can be
   changed fast and easy in a tree-buffer without customizing this
   option, but of course not for future Emacs sessions!

 - User Option: ecb-tree-expand-symbol-before
   Show the expand symbol before the items in a tree.

 - User Option: ecb-tree-incremental-search
   Enable incremental search in the ECB-tree-buffers. For a detailed
   explanation see Using the keyboard. If you change this
   during ECB is activated you must deactivate and activate ECB again to
   take effect.

 - User Option: ecb-tree-indent
   Indent size for tree buffer. If you change this during ECB is
   activated you must deactivate and activate ECB again to take effect.

 - User Option: ecb-tree-navigation-by-arrow
   Enable smart navigation in the tree-windows by horiz. arrow-keys. If
   not nil then the left- and right-arrow keys work in the ECB
   tree-window in the following smart way if onto an expandable node:

    * Left-arrow: If node is expanded then it will be collapsed
      otherwise point jumps to the next "higher" node in the
      hierarchical tree (higher means the next higher tree-level or -
      if no higher level available - the next higher node on the same
      level).

    * Right-arrow: If node is not expanded then it will be expanded.
      Onto a not expandable node the horizontal arrow-keys go one
      character in the senseful correct direction.

   If this option is changed the new value takes first effect after
   deactivating ECB and then activating it again!

 - User Option: ecb-truncate-lines
   Truncate lines in ECB buffers. If you change this during ECB is
   activated you must deactivate and activate ECB again to take effect.

 - User Option: ecb-truncate-long-names
   Truncate long names that don't fit in the width of the ECB windows.
   If you change this during ECB is activated you must deactivate and
   activate ECB again to take effect.

 - User Option: ecb-use-recursive-edit
   Tell ECB to use a recursive edit so that it can easily be deactivated
   by (keyboard-escape-quit).

 - User Option: ecb-version-check
   If not `nil' ECB checks at start-time if the required versions of
   semantic and eieio are installed and loaded into Emacs. It is
   strongly recommended to set this option to not `nil'!

 - User Option: ecb-window-sync
   Synchronize the ECB-windows automatically with current edit window.
   If `always' then the synchronization takes place always a buffer
   changes in the edit window, if `nil' then never. If a list of
   major-modes then only if the `major-mode' of the new buffer belongs
   NOT to this list.

   But in every case the synchronization takes only place if the
   current-buffer in the edit-window has a relation to files or
   directories. Examples for the former one are all
   programming-language-modes, `Info-mode' too, an example for the
   latter one is `dired-mode'. For all major-modes related to
   non-file/directory-buffers like `help-mode', `customize-mode' and
   others never a synchronization will be done!

   It's recommended to exclude at least `Info-mode' because it makes no
   sense to synchronize the ECB-windows after calling the Info help.
   Per default also `dired-mode' is excluded but it can also making
   sense to synchronize the ECB-directories/sources windows with the
   current directory in the dired-buffer.

 - User Option: ecb-window-sync-delay
   Time Emacs must be idle before the ECB-windows are synchronized with
   current edit window. If nil then there is no delay, means
   synchronization takes place immediately. A small value of about 0.25
   seconds saves CPU resources and you get even though almost the same
   effect as if you set no delay.

Group ecb-directories
---------------------

This group contains the following options:

 - User Option: ecb-add-path-for-not-matching-files
   Add path of a file to `ecb-source-path' if not already contained.
   This is done during the auto. windows synchronization which happens
   if a file is opened not via the file/directory-browser of ECB. In
   such a situation ECB adds the path of the new file auto. to
   `ecb-source-path' at least temporally for the current Emacs session.
   This option defines two things:

   1. Should only the root-part (which means for unix-like systems
      always '/' and for windows-like systems the drive) of the new
      file be added as source-path to `ecb-source-path' or the whole
      directory-part?

   2. Should this path be added for future sessions too?

   The value of this option is a cons-cell where the car is a boolean
   for 1. and the cdr is a boolean for 2.

   A value of not nil for the car (1.) is reasonably if a user often
   opens files not via the ECB-browser which are not located in any of
   the paths of `ecb-source-path' because then only one path for each
   drive (windows) or the root-path (unix) is added to the directory
   buffer of ECB.

 - User Option: ecb-auto-expand-directory-tree
   Automatically expand the directory tree to the current source file.
   There are three options:

    - `best': Expand the best-matching source-path

    - `first': Expand the first matching source-path

    - `nil': Do not automatically expand the directory tree.

 - User Option: ecb-cache-directory-contents
   Cache contents of directories.

   This can be useful if `ecb-source-path' contains directories with
   many files and subdirs, especially if these directories are mounted
   net-drives ("many" means here something > 1000, dependend of the
   speed of the net-connection and the machine). For these directories
   actualizing the sources- and/or directories- buffer of ECB (if
   displayed in current layout!) can slow down dramatically so a caching
   increases speed a lot.

   The value of this option is a list where each element looks like:

        (<dir-regexp> <filenumber threshold> <cache clearing> with

  `<dir-regexp>:'
      Regular expression a directory must match to be cached.

  `<filenumber threshold>:'
      Number of directory contents must exceed this number.

  `<cache clearing>:'
      When the cache should be cleared:

       - `demand': Cache will only be cleared on user demand. See
         `ecb-clear-directory-cache'.

       - `auto': Cache will be cleared if the contents of the directory
         have been changed. ECB can detect this automatically. This
         works for Unix- but probably not for Windows-systems, because
         Windows offers no way to detect when the contents of a
         directory have been changed.

       - `<number>': First selection of directories matching the regexp
         after <number> seconds after last caching time will rescan the
         directory.

   A directory will we only be cached if and only if the directory-name
   matches one rexexp of this option and it's content-number exceeds the
   related threshold.

   Example: A value of `("~/bigdir*" 1000 3600)' means the contents of
   every subdirectory of the home-directory with name beginning with
   "bigdir" will be cached if the directory contains more than 1000
   entries. One hour after the last caching time of such a directory
   the next selection (clicking onto it in the directories-window,
   changing buffers so the directory becomes current in the
   directories-window, etc...) will rescan the directory and update the
   cache.

   *Attention*: Currently the <cache clearing> part is ignored.
   Currently the cache can only be cleared on demand and only the whole
   cache can be cleared, see `ecb-clear-directory-cache'. This will
   change in a future version.

 - User Option: ecb-directories-buffer-name
   Name of the ECB directory buffer. Because it is not a normal buffer
   for editing you should enclose the name with stars, e.g. " *ECB
   Directories*".

   If it is necessary for you you can get emacs-lisp access to the
   buffer-object of the ECB-directory-buffer by this name, e.g. by a
   call of `set-buffer'.

   Changes for this option at runtime will take affect only after
   deactivating and then activating ECB again!

 - User Option: ecb-excluded-directories-regexp
   Specifies directories that should not be included in the directories
   list. The value of this variable should be a regular expression.

 - User Option: ecb-show-sources-in-directories-buffer
   Show source files in directories buffer.

 - User Option: ecb-source-path
   Paths where to find code sources. Each path can have an optional
   alias that is used as it's display name. If no alias is set, the
   path is used as display name.

Group ecb-sources
-----------------

This group contains the following options:

 - User Option: ecb-show-source-file-extension
   Show the file extension of source files.

 - User Option: ecb-source-file-regexps
   Specifies which files are shown as source files. Consists of one
   exclude regexp and one include regexp. A file is displayed in the
   source-buffer of ECB iff: The file does not match the exclude regexp
   OR the file matches the include regexp. There are three predefined
   and useful combinations of an exclude and include regexp:

    * All files

    * All, but no backup, object, lib or ini-files (except .emacs and
      .gnus). This means all files except those starting with ".", "#"
      or ending with "~", ".elc", ".obj", ".o", ".lib", ".dll", ".a",
      ".so". (but including .emacs and .gnus)

    * Common source file types (.c, .java etc.)

   In addition to these predefined values a custom exclude and include
   combination can be defined.

 - User Option: ecb-sources-buffer-name
   Name of the ECB sources buffer. Because it is not a normal buffer for
   editing you should enclose the name with stars, e.g. "*ECB Sources*".

   If it is necessary for you you can get emacs-lisp access to the
   buffer-object of the ECB-sources-buffer by this name, e.g. by a call
   of `set-buffer'.

   Changes for this option at runtime will take affect only after
   deactivating and then activating ECB again!

 - User Option: ecb-sources-sort-method
   Defines how the source files are sorted.

    - `name': Sorting by name.

    - `extension': Sorting first by name and then by extension.

    - `nil': No sorting, means source files are displayed in the
      sequence returned by `directory-files' (called without sorting).

Group ecb-methods
-----------------

This group contains the following options:

 - User Option: ecb-auto-update-methods-after-save
   Automatically updating the ECB method buffer after saving the current
   source-buffer.

 - User Option: ecb-bucket-token-display
   How ECB displays bucket tokens in the ECB methods buffer. Bucket
   tokens are tokens like "[+] Variables", "[+] Dependencies" etc. The
   name of the bucket-token comes from semantic but you can define a
   prefix, a suffix and a special face for the bucket token.

   The default are empty prefix/suffix-strings and
   'ecb-bucket-token-face'. But an alternative can be for example `("["
   "]" nil)' which means no special face and a display like "[+]
   [<bucket-name>]".

 - User Option: ecb-exclude-parents-regexp
   Regexp which parent classes should not be shown in the methods buffer
   (see also `ecb-show-parents'). If nil then all parents will be shown
   if `ecb-show-parents' is not nil.

 - User Option: ecb-font-lock-tokens
   Adds font-locking (means highlighting) to the ECB-method buffer.

 - User Option: ecb-highlight-token-header-after-jump
   If not nil then highlight the token line in the source-buffer after
   jumping to this method by clicking in the ECB-method-buffer onto this
   method. For highlighting `ecb-token-header-face' is used.

 - User Option: ecb-highlight-token-with-point
   How to highlight the method or variable under the cursor.

    - `highlight-scroll': Always scroll the method buffer, so the
      current method of the edit-window is highlighted in the
      method-window.

    - `highlight': Only highlight the current method of the edit window
      in the method window if the method is visible in the
      method-window.

    - `nil': No highlighting is done.

   See also `ecb-highlight-token-with-point-delay'.

 - User Option: ecb-highlight-token-with-point-delay
   Time Emacs must be idle before current token is highlighted. If nil
   then there is no delay, means current token is highlighted
   immediately. A small value of about 0.25 seconds saves CPU resources
   and you get even though almost the same effect as if you set no
   delay.  But such a delay prevents also "jumping backward/forward"
   during scrolling within java-classes if point goes out of
   method-definition into class-definition. Therefore the default value
   is a delay of 0.25 seconds.

 - User Option: ecb-token-jump-narrow
   When jumping to a token from the ECB methods buffer narrows the
   buffer to only show that token. To display the entire buffer again,
   click on a source file or call `widen' `C-x n w'.

 - User Option: ecb-token-jump-sets-mark
   Jumping to a token from the ECB-method buffer now sets the mark so
   the user can easily jump back.

 - User Option: ecb-methods-buffer-name
   Name of the ECB methods buffer. Because it is not a normal buffer for
   editing you should enclose the name with stars, e.g. " *ECB
   Methods*".

   If it is necessary for you you can get emacs-lisp access to the
   buffer-object of the ECB-methods-buffer by this name, e.g. by a call
   of `set-buffer'.

   Changes for this option at runtime will take affect only after
   deactivating and then activating ECB again!

 - User Option: ecb-post-process-semantic-tokenlist
   Define mode-dependend postprocessing for the semantic-tokenlist. This
   is an alist where the car is a major-mode symbol and the cdr is a
   function-symbol of a function which should be used for
   post-processing the tokenlist (returned by
   `semantic-bovinate-toplevel') for a buffer in this major-mode. Such
   a function is called with current semantic tokenlist of current
   buffer and must return a valid tokenlist again.

   For oo-programming languages where the methods of a class can be
   defined outside the class-definition (e.g. C++, Eieio) the function
   `ecb-group-function-tokens-with-parents' can be used to get a much
   better method-display in the methods-window of ECB, because all
   method implementations of a class are grouped together.

 - User Option: ecb-scroll-window-after-jump
   How to scroll the window when jumping to a token.

 - User Option: ecb-show-only-positioned-tokens
   Show only nodes in the method-buffer which are "jumpable". If not nil
   then ECB displays in the method-buffer only nodes which are
   "jumpable", i.e. after selecting it by clicking or with RET then ECB
   jumps to the corresponding location in the edit-window. Example: With
   CLOS or Eieio source-code there can exist some positionless nodes
   like variable-attributes in a `defclass' form which are only
   displayed if this option is nil. Displaying such nodes can be
   sensefull even if they can not be jumped.

 - User Option: ecb-show-tokens
   How to show tokens in the methods buffer. This variable is a list
   where each element represents a type of tokens:

      (<token type> <display type> <sort method>)

   The tokens in the methods buffer are displayed in the order as they
   appear in this list.

  `<token type>'
      A Semantic token type symbol (function, variable, rule, include
      etc.)  or one of the following:

       - `t': All token types not specified anywhere else in the list.

       - `parent': The parents of a type.

  `<display type>'
      A symbol which describes how the tokens of this type shall be
      shown:

       - `expanded': The tokens are shown in an expanded node.

       - `collapsed': The tokens are shown in a collapsed node.

       - `flattened': The tokens are added to the parent node.

       - `hidden': The tokens are not shown.

  `<sort method>'
      A symbol describing how to sort the tokens of this type:

       - `name': Sort by the token name.

       - `access': Sort by token access (public, protected, private)
         and then by name.

       - `nil': Don't sort tokens. They appear in the same order as in
         the source buffer.

 - User Option: ecb-token-display-function
   Function to use for displaying tokens in the methods buffer. This
   functionality is set on major-mode base, i.e. for every major-mode a
   different function can be used. The value of this option is a list of
   cons-cells:

    - The car is either a major-mode symbol or the special symbol
      'default which means if no function for a certain major-mode is
      defined then the cdr of the 'default cons-cell is used.

    - The cdr is the function used for displaying a token in the related
      major-mode.

   Every function is called with 3 arguments:

   1. The token

   2. The parent-token of token (can be nil)

   3. The value of `ecb-font-lock-tokens'.

   Every function must return the display of the token as string,
   colorized if the third argument is not nil.

   The following functions are predefined:

    * All functions of `semantic-token->text-functions'.

    * For every function in `semantic-token->text-functions' with name
      "semantic-XYZ" a function with name "ecb-XYC" is predefined. The
      differences between the semantic- and the ECB-version are:

       - The ECB-version displays for type tokens only the type-name
         and nothing else (exception: In c++-mode a template specifier
         is appended to the type-name if a template instead a normal
         class).

       - The ECB-version displays type-tokens according to the setting
         in `ecb-type-token-display'. This is useful for better
         recognizing different classes, structs etc. in the ECB-method
         window.

      For all tokens which are not types the display of the ECB-version
      is identical to the semantic version. Example: For
      `semantic-name-nonterminal' the pendant is `ecb-name-nonterminal'.

   This functionality also allows the user to display tokens as UML. To
   enable this functionality set the function for a major-mode (e.g.
   `jde-mode') to `semantic-uml-concise-prototype-nonterminal',
   `semantic-uml-prototype-nonterminal', or
   `semantic-uml-abbreviate-nonterminal' or the ECB-versions of these
   functions.

   If the value is `nil', i.e. neither a function for a major-mode is
   defined nor the special 'default, then
   `semantic-prototype-nonterminal' is used for displaying the tokens.

 - User Option: ecb-token-jump-narrow
   When jumping to a token from the ECB methods buffer narrows the
   buffer to only show that token. To display the entire buffer again,
   click on a source file or call `widen' (`C-x n w').

 - User Option: ecb-token-jump-sets-mark
   Jumping to a token from the ECB-method buffer now sets the mark so
   the user can easily jump back.

 - User Option: ecb-type-token-display
   How to display semantic type-tokens in the methods buffer. Normally
   all token displaying, colorizing and facing is done by semantic
   according to the value of `semantic-face-alist' and the semantic
   display-function (e.g. one from `semantic-token->text-functions').
   But sometimes a finer distinction in displaying the different type
   specifiers of type-tokens can be usefull. For a description when
   this option is evaluated look at `ecb-token-display-function'!

   This functionality is set on a major-mode base, i.e. for every
   major-mode a different setting can be used. The value of this option
   is a list of cons-cells:

    * The car is either a major-mode symbol or the special symbol
      'default which means if no setting for a certain major-mode is
      defined then the cdr of the 'default cons-cell is used.

    * The cdr is a list of 3-element-lists:

      1. First entry is a semantic type specifier in string-form.
         Current available type specifiers are for example "class",
         "interface", "struct", "typedef" and "enum". In addition to
         these ones there is also a special ECB type specifier "group"
         which is related to grouping tokens (see
         `ecb-post-process-semantic-tokenlist' and
         `ecb-group-function-tokens-with-parents'). Any arbitrary
         specifier can be set here but if it is not "group" or not
         known by semantic it will be useless.

      2. Second entry is a flag which indicates if the type-specifier
         string from (1.) itself should be removed (if there is any)
         from the display.

      3. Third entry is the face which is used in the ECB-method window
         to display type-tokens with this specifier. ECB has some
         predefined faces for this (`ecb-type-token-class-face',
         `ecb-type-token-struct-face', `ecb-type-token-typedef-face',
         `ecb-type-token-enum-face' and `ecb-type-token-group-face')
         but any arbitrary face can be set here. This face is merged
         with the faces semantic already uses to display a token, i.e.
         the result is a display where all face-attributes of the
         ECB-face take effect plus all face-attributes of the
         semantic-faces which are not set in the ECB-face (with XEmacs
         this merge doesn't work so here the ECB-face replaces the
         semantic-faces; this may be fixed in future versions).

   The default value is nil means there is no special ECB-displaying of
   type-tokens in addition to the displaying and colorizing semantic
   does. But a value like the following could be a usefull setting:

      ((default
         ("class" t ecb-type-token-class-face)
         ("group" nil ecb-type-token-group-face))
       (c-mode
        ("struct" nil ecb-type-token-struct-face)
        ("typedef" nil ecb-type-token-typedef-face)))

   This means that in `c-mode' only "struct"s and "typedef"s are
   displayed with special faces (the specifiers itself are not removed)
   and in all other modes "class"es and grouping-tokens (see
   `ecb-token-display-function',
   `ecb-group-function-tokens-with-parents') have special faces and the
   "class" specifier-string is removed from the display.

Group ecb-history
-----------------

This group contains the following options:

 - User Option: ecb-clear-history-behavior
   Defines which entries of the history buffer should be deleted if
   `ecb-clear-history' is called. Three options are available:

    - `not-existing-buffers': All entries which represent a buffername
      not existing anymore in the bufferlist will be cleared. Probably
      the most senseful value.

    - `existing-buffers': The opposite of 'not-existing-buffers.

    - `all': The whole history will be cleared.

 - User Option: ecb-history-buffer-name
   Name of the ECB history buffer. Because it is not a normal buffer for
   editing you should enclose the name with stars, e.g. "*ECB History*".

   If it is necessary for you you can get emacs-lisp access to the
   buffer-object of the ECB-history-buffer by this name, e.g. by a call
   of `set-buffer'.

   Changes for this option at runtime will take affect only after
   deactivating and then activating ECB again!

 - User Option: ecb-history-item-name
   The name to use for items in the history buffer.

 - User Option: ecb-kill-buffer-clears-history
   Define if `kill-buffer' should also clear the history. There are
   three options:

    - `auto': Removes automatically the corresponding history-entry
      after the buffer has been killed.

    - `ask': Asks, if the history-entry should be removed after the
      kill.

    - `nil': `kill-buffer' does not affect the history (this is the
      default).

 - User Option: ecb-sort-history-items
   Sorts the items in the history buffer.

Group ecb-layout
----------------

This group contains the following options:

 - User Option: ecb-activate-before-new-frame-created-hook
   Normal hook run before the new ECB-frame is created if
   `ecb-new-ecb-frame' is not nil (otherwise this hook is not
   evaluated).

 - User Option: ecb-advice-window-functions
   Use the intelligent windows functions of ECB instead of the standard
   Emacs functions. You can choose the following functions to be adviced
   by ECB so they behave as if the edit-window(s) of ECB would be the
   only windows(s) of the ECB-frame:

    * `other-window' For this one see also the option
      `ecb-other-window-jump-behavior'!

    * `delete-window'

    * `delete-other-windows'

    * `delete-windows-on'

    * `split-window-horizontally'

    * `split-window-vertically'

    * `switch-to-buffer'

    * `switch-to-buffer-other-window'

    * `other-window-for-scrolling' If this advice is enabled then the
      following functions scroll always the first edit-window if the
      edit-window is splitted, point stays in the "other" edit-window
      and there is no durable compilation-window (see
      `ecb-compile-window-height'):

       - `scroll-other-window'

       - `scroll-other-window-down'

       - `beginning-of-buffer-other-window'

       - `end-of-buffer-other-window'

      This advice is per default not enabled.

   For working most conveniantly with ECB it is the best to advice all
   these functions, because then all the standard shortcuts of these
   functions are also usable with ECB without doing anything else. Also
   other packages can interact best with ECB if these functions are all
   adviced. If these adviced functions are called in another frame than
   the ECB-frame they behave all exactly like the not adviced versions!

   But please read also the following:

   Normally all packages should work correct with ECB and it´s adviced
   functions but if there occur problems with a package cause of some of
   these adviced functions ECB offers the following fall-back solution:

   1. Deactivate in `ecb-advice-window-functions' all the
      adviced-functions which make problems with other packages.

   2. For every of the adviceable functions <adv-func> ECB offers a
      interactively function named "ecb-<adv-func>" which does exactly
      the same as the adviced version of <adv-func>. Use
      "ecb-<adv-func>" instead the original one to get the proper ECB
      behavior even if the function is not adviced anymore.

   3. You can bind in `ecb-activate-hook' the standard-shortcut of
      <adv-func> to "ecb-<adv-func>" and rebind it in
      `ecb-deactivate-hook' to <adv-func>.

   4. Now you have the best of both worlds: The problematic package
      works and you have the ECB-behavior of <adv-func> as if it would
      be adviced.

   Here is an example: Suppose you must deactivating the advice for
   `switch-to-buffer-other-window'. Then you deactivate this function
   with this option and you can use `ecb-switch-to-buffer-other-window'
   instead. Bind the shortcut you normally use for
   `switch-to-buffer-other-window' to
   `ecb-switch-to-buffer-other-window' (use `ecb-activate-hook' for
   this) and rebind it to the original function in the
   `ecb-deactivate-hook'.

 - User Option: ecb-compile-window-enlarge-by-select
   The compile-window is auto. enlarged after selecting it. If not nil
   then selecting the `ecb-compile-window' auto. enlarges it and
   deselecting (means selecting another window after point was in
   `ecb-compile-window') auto. shrinks it. Enlarging and shrinking the
   `ecb-compile-window' is done with
   `ecb-toggle-enlarged-compilation-window'. See also the documentation
   of this function!

 - User Option: ecb-compile-window-height
   If you want a compilation window shown at the bottom of the
   ECB-layout then set here the height of it (Default is a height of
   5). If you redraw the current layout with `ecb-redraw-layout' then
   the compilation window (if any) has the heigth you set here. If the
   number is less than 1.0 the height is a fraction of the frame height.

   If you do not set a durable compilation window then doing a
   compilation splits temporally the edit window vertically if the edit
   window is not splitted already or uses the "other" edit window
   temporally for comilation output if the edit window is already
   splitted. This is the recommended value for this option!

   Beware: If you set a durable compilation window then ECB can not
   guarantee always behaving like a standard Emacs concerning displaying
   temp-buffers and compilation-buffers. It should work in most cases
   but maybe not in all. Just try it out.

   See also the option `ecb-compile-window-temporally-enlarge' and also
   the function `ecb-toggle-enlarged-compilation-window'!

   See Temp- and compile-buffers.

   Regardless of the settings you define here: If you have destroyed or
   changed the ECB-screen-layout by any action you can always go back to
   this layout with `ecb-redraw-layout'

 - User Option: ecb-compile-window-temporally-enlarge
   Let Emacs temporally enlarge the compile-window of the ECB-layout.

   This option has only an effect if `ecb-compile-window-height' is not
   nil!

   The following values are possible:

    - `after-compilation': After finishing the compilation-output and
      during jumping to the errors ECB let temporally enlarge all
      compilation-buffers in `ecb-compile-window' (e.g. compile- and
      grep-buffers) to `compilation-window-height'. But be aware this
      setting is currently not meaningful for temporary buffers like
      help-buffers because these buffers currently enlarge always to
      `temp-buffer-max-height'.

    - `after-selection': Selecting the `ecb-compile-window' auto.
      enlarges it and deselecting (means leaving `ecb-compile-window')
      auto. shrinks it. Enlarging and shrinking the
      `ecb-compile-window' is done with
      `ecb-toggle-enlarged-compilation-window'. See also the
      documentation of this function! This is possible for all buffers
      in `ecb-compile-window' not only for compilation-buffers!

    - `both': The combination of 'after-compilation and
      'after-selection.

    - `nil': ECB tries to fix always the height of the
      `ecb-compile-window' at the value of `ecb-compile-window-height'.
      But for all temporary buffers (e.g. help-buffers) this is
      currently not possible.

   To restore the ECB-layout after such a buffer-enlarge just call
   `ecb-toggle-enlarged-compilation-window' or `ecb-redraw-layout'.

 - User Option: ecb-hide-ecb-windows-hook
   Hooks run after the ECB windows have been hidden either by
   `ecb-toggle-ecb-windows' or `ecb-hide-ecb-windows'.

 - User Option: ecb-layout-always-operate-in-edit-window
   Adviced window functions work always in the edit-window. If we are in
   an ECB special buffer (methods, directories, etc), and any of the
   adviced windowing functions is called (see
   `ecb-advice-window-functions'), we will select the `ecb-edit-window'
   first. This is useful if you have any functions that use such
   functions and you don't want them to just error with a method
   complaining that the current buffer can not be split, or something
   similar.

   Because this may not be desirable in all situations and all adviced
   functions this can be enabled separately for every advisable function
   (see also `ecb-advice-window-functions'). If the symbol of an
   adviced function is contained in the value of this option, then the
   edit-window is first selected otherwise either an error is reported
   or some other special reaction; see the documentation of the adviced
   functions for this.

   For `other-window' and `other-window-for-scrolling' this makes no
   sense, therefore you can not enable this for both of them.

   Per default this is enabled for `delete-window',
   `delete-other-windows', `switch-to-buffer' and
   `switch-to-buffer-other-window'.

 - User Option: ecb-layout-nr
   Define the window layout of ECB. A positive integer which sets the
   general layout. Currently there are 17 predefined layouts with index
   from 0 to 16. You can savely try out any of them by changing this
   value and saving it only for the current session. If you are sure
   which layout you want you can save it for future sessions. To get a
   picture of the layout for index <index> call C-h f
   ecb-layout-function-<index>, e.g.  `ecb-layout-function-9'.

   Currently available layouts (see the doc-string for a picture ot the
   layout):

   `ecb-layout-function-0' `ecb-layout-function-1'
   `ecb-layout-function-2' `ecb-layout-function-3'
   `ecb-layout-function-4' `ecb-layout-function-5'
   `ecb-layout-function-6' `ecb-layout-function-7'
   `ecb-layout-function-8' `ecb-layout-function-9'
   `ecb-layout-function-10' `ecb-layout-function-11'
   `ecb-layout-function-12' `ecb-layout-function-13'
   `ecb-layout-function-14' `ecb-layout-function-15'
   `ecb-layout-function-16'

   Regardless of the settings you define here: If you have destroyed or
   changed the ECB-screen-layout by any action you can always go back to
   this layout with `ecb-redraw-layout'

 - User Option: ecb-layout-switch-to-compilation-window
   Switch-to-buffer...-functions switch to `ecb-compile-window'. If the
   buffer argument of `switch-to-buffer' or
   `switch-to-buffer-other-window' is an compilation buffer as defined
   with `ecb-compilation-buffer-p' we will select the
   `ecb-compile-window' first. This is useful if you always want your
   compilation buffers within the compilation window and now within the
   edit window.

   Note the difference between
   `ecb-layout-always-operate-in-edit-window' and this option: If a
   switch-to-buffer...-function is contained in the former one, then we
   always jump first into the edit-window regardless of the destination
   buffer. If also contained in this option then ECB checks the
   destination buffer and then selects the `ecb-compile-window' if it
   is a compilation-buffer in the meaning of `ecb-compilation-buffer-p'!

   Per default this is only enabled for `switch-to-buffer'. We provide
   the option for `switch-to-buffer-other-window' too but the
   assumption is that when a user asks for a buffer in another window
   it should always be presented in another window.

 - User Option: ecb-layout-window-sizes
   Specifies the sizes of the ECB windows for each layout. The easiest
   way to change this variable is to change the window sizes by dragging
   the window borders using the mouse and then store the window sizes by
   calling the `ecb-store-window-sizes' function. Next time the layout
   is redrawn the values stored in this option will be used.

   But be aware: These values are only suitable for the frame-size the
   ecb-frame had at the time you store the values by calling
   `ecb-store-window-sizes'. Therefore ensure always before calling
   `ecb-store-window-sizes' that the ecb-frame has the size it has
   normally during your work with ECB!.

 - User Option: ecb-new-ecb-frame
   Create a new frame at activation time of ECB.

 - User Option: ecb-other-window-jump-behavior
   Which windows of ECB should be accessible by the ECB-adviced function
   `other-window', an intelligent replacement for the Emacs standard
   version of `other-window'. The following settings are possible:

    - `all': ECB will cycle through all windows of ECB, means it
      behaves like the original `other-window'.

    - `only-edit': ECB will only cycle through the (max. 2)
      edit-windows of ECB.

    - `edit-and-compile': Like 'only-edit plus the compile window if
      any.

 - User Option: ecb-redraw-layout-quickly
   If non-nil, we will attempt to redraw the layout quickly. Please read
   also carefully the documentation of `ecb-redraw-layout'.

 - User Option: ecb-select-edit-window-on-redraw
   Select the first edit window on `ecb-redraw-layout'.

 - User Option: ecb-show-ecb-windows-hook
   Hooks run after the ECB windows have been shown either by
   `ecb-toggle-ecb-windows' or `ecb-show-ecb-windows'.

 - User Option: ecb-split-edit-window
   Sets how and if the edit window should be splitted. But be aware:
   This option determines only if the edit-window should be splitted at
   start-time of ECB.

 - User Option: ecb-toggle-layout-sequence
   Toggle sequence for layout toggling with `ecb-toggle-layout'.  Every
   element of this list has to be a valid layout-number (see option
   `ecb-layout-nr').

   You can add here as many layouts as you want but to use this option
   most effective you should not add more than 2 or 3 layouts so every
   layout can be accessed very fast by toggling with
   `ecb-toggle-layout'. It is also senseful to add layouts which have
   the same principal outline, i.e. all their tree-buffers are on the
   same side of the frame and the tree-buffer-"column" (or -"row") has
   identical size for the layouts.

   Recommended values are for example:

    - (11 16), toggles between methods and directories/history

    - (11 15), toggles between methods and directories

    - (11 14), toggles between methods and history

    - (11 14 15), toggles between methods, history and directories

   This option makes only sense if the value is a list with more than 1
   element!

 - User Option: ecb-windows-height
   The height of the ECB windows in lines when they are placed above or
   below the edit window. If the number is less than 1.0 the width is a
   fraction of the frame height.

 - User Option: ecb-windows-width
   The width of the ECB windows in columns when they are placed to the
   left or right of the edit window. If the number is less than 1.0 the
   width is a fraction of the frame width.

Group ecb-face-options
----------------------

This group contains the following options:

 - User Option: ecb-directories-general-face
   Basic face for the ECB directories buffer. It´s recommended to define
   here the font-family, the font-size, the basic color etc.

 - User Option: ecb-directory-face
   Define face used for highlighting current directory in the
   directories buffer.

 - User Option: ecb-history-face
   Define face used for highlighting current history-entry in the
   history buffer.

 - User Option: ecb-history-general-face
   Basic face for the ECB history buffer. It´s recommended to define
   here the font-family, the font-size, the basic color etc.

 - User Option: ecb-method-face
   Define face used for highlighting current method, class or variable
   in the methods buffer.

 - User Option: ecb-methods-general-face
   Basic face for the ECB methods buffer. It´s recommended to define
   here the font-family, the font-size, the basic color etc.

 - User Option: ecb-source-face
   Define face used for highlighting current source in the sources
   buffer.

 - User Option: ecb-source-in-directories-buffer-face
   Define a face for displaying sources in the directories buffer.

 - User Option: ecb-sources-general-face
   Basic face for the ECB sources buffer. It´s recommended to define
   here the font-family, the font-size, the basic color etc.

 - User Option: ecb-token-header-face
   Define face used for highlighting the token header after jumping to
   it by clicking onto a node in the methods buffer.

Group ecb-faces
---------------

This group contains the following faces:

`ecb-bucket-token-face:'
   Face which can be used for displaying bucket tokens in the methods
   buffer. See also `ecb-bucket-token-display'.

`ecb-default-general-face:'
   Basic face for all ECB tree-buffers.  It's recommended to define
   here the font-family, the font-size, the basic color etc.

   In GNU Emacs 21.X all faces (even the face
   `ecb-default-highlight-face') used in the ECB tree-buffers inherit
   from this face. Therefore the default attributes like font etc. of a
   face used in a tree-buffer can be very easily changed with face
   `ecb-default-general-face'.

   With XEmacs and GNU Emacs 20.X there is no inheritance-feature but
   the options `ecb-directories-general-face',
   `ecb-sources-general-face', `ecb-methods-general-face' and
   `ecb-history-general-face' offer the choice to use the face
   `ecb-default-general-face' so also with XEmacs and GNU Emacs 20.X
   the basic face-settings can be easily changed just by customizing the
   face `ecb-default-general-face'!

`ecb-default-highlight-face:'
   Define basic face for highlighting the selected node in an ECB
   tree-buffer.

   In GNU Emacs 21.X all highlighting faces in the ECB tree-buffers
   inherit from this face. Therefore the default attributes like font
   etc. of a face used in a tree-buffer for highlighting the current
   token can be very easily changed with face
   `ecb-default-highlight-face'.

   With XEmacs and GNU Emacs 20.X there is no inheritance-feature but
   the options `ecb-directory-face', `ecb-source-face',
   `ecb-method-face' and `ecb-history-face' offer the choice to use the
   face `ecb-default-highlight-face' so also with XEmacs and GNU Emacs
   20.X the basic face-settings can be easily changed just by
   customizing the face `ecb-default-highlight-face'!

`ecb-directories-general-face:'
   Basic face for the ECB directories buffer. It´s recommended to define
   here the font-family, the font-size, the basic color etc.

`ecb-directory-face:'
   Define face used for highlighting current directory in the
   directories buffer.

`ecb-history-face:'
   Define face used for highlighting current history-entry in the
   history buffer.

`ecb-history-general-face:'
   Basic face for the ECB history buffer. It´s recommended to define
   here the font-family, the font-size, the basic color etc.

`ecb-method-face:'
   Define face used for highlighting current method, class or variable
   in the methods buffer.

`ecb-methods-general-face:'
   Basic face for the ECB methods buffer. It´s recommended to define
   here the font-family, the font-size, the basic color etc.

`ecb-source-face:'
   Define face used for highlighting current source in the sources
   buffer.

`ecb-source-in-directories-buffer-face:'
   Define a face for displaying sources in the directories buffer.

`ecb-sources-general-face:'
   Basic face for the ECB sources buffer. It´s recommended to define
   here the font-family, the font-size, the basic color etc.

`ecb-token-header-face:'
   Define face used for highlighting the token header after jumping to
   it by clicking onto a node in the methods buffer.

`ecb-type-token-class-face:'
   Define face used with option `ecb-type-token-display'.

`ecb-type-token-enum-face:'
   Define face used with option `ecb-type-token-display'.

`ecb-type-token-group-face:'
   Define face used with option `ecb-type-token-display'.

`ecb-type-token-interface-face:'
   Define face used with option `ecb-type-token-display'.

`ecb-type-token-struct-face:'
   Define face used with option `ecb-type-token-display'.

`ecb-type-token-typedef-face:'
   Define face used with option `ecb-type-token-display'.

Just call `customize-face <face-name>' to customize these faces for
your personal taste. Or customize the related option in the group
ecb-face-options.

Group ecb-download
------------------

This group contains the following options:

 - User Option: ecb-download-delete-archive
   Should the downloaded archive be deleted after successfull
   installation or after failure during the installation-process.
   Possible values are:

    - `only-after-success': Archive is only deleted after successfull
      installation but not if a failure occurs during the installation
      process.

    - `always': Archive is also deleted if an error occurs.

    - `nil': Archive will never be deleted.

 - User Option: ecb-download-url
   URL where downloadable ECB-versions are located. The ECB-archive-file
   (e.g. ecb-1.70.tar.gz) will be appended to this URL and
   `ecb-download-ecb' will try to download this archive.

   Note: Normally this URL should never change but who knows...

 - User Option: ecb-download-version
   Which version of ECB should be downloaded by `ecb-download-ecb'.
   Valid values are either the string "latest" or a version number like
   "1.70". ECB creates automatically the correct URL for download, see
   `ecb-download-ecb' (see Interactive ECB commands).

Submitting a problem report
***************************

If you run into problems with ECB you can/should send a problem report
to the ECB mailing list <ecb-list@lists.sourceforge.net>. ECB offers
you a command which does all necessary for you to send a problem
report. Just call `ecb-submit-problem-report'! Please read the
documentation of this command, see Interactive ECB commands.

This command creates a problem-report buffer for you. After that you
get a menu "Mail" (dependend on the mail-package used, the menu can
have a different name) with commands to send the problem report. But
for this the varibale `mail-user-agent' must be configured right for
your system. If you can´t get working this mechanism you can simply
copy the whole problem-report buffer after filling it out and sending
it with your standard mail-client to <ecb-list@lists.sourceforge.net>!

Please read also the documentation of the option `ecb-debug-mode' and
switch on the debug mode of ECB (also available in the Help-menu of
ECB!) before submitting a problem-report!

Upgrading and downloading packages
**********************************

This chapter describes all aspects of upgrading to a newer version of
ECB.

The first section describes how to download and install a new package
from the web, where "package" means either ECB itself or the required
libraries semantic and eieio.

After installing a new ECB-version ECB checks if the values of the
customized ECB-options are still compatible. If not ECB does some smart
things. This is the topic of the second section.

Downloading new versions of ECB and/or required packages
========================================================

ECB offers the possibility to upgrade to newer versions direct from the
ECB-website. This can be done if the following requirements are
satisfied:

1. A connection to the web is available

2. The tools "wget", "tar" and "gzip" are installed

   With unix-systems these tools are in the standard-distribution. If
   you are running any Microsoft Windows system then you need cygwin(1)
   which offers these tools too. On every system these tools must
   reside in the `PATH' environment-variable!

   If you are behind a firewall and you have to use a proxy you maybe
   need the following wget-configuration in your file `~/.wgetrc':

      # Define your proxies (where 8080 and 8081 are examples
      # for the portnumbers)
      http_proxy = http://your.proxy.com:8080
      ftp_proxy  = http://your.ftpproxy.com:8081

      # If you do not want to use proxy at all, set this to off.
      use_proxy = on

If these requirements are satisfied you can download and install both
ECB itself and also the required versions of semantic and eieio:

 * Download a new ECB-version with `ecb-download-ecb':

   A description for this command you will find in Interactive ECB commands.
   Check also the options of the customize-group
   'ecb-download' (see ecb-download).

   ECB will try to download the file:

      <URL><PACKAGE>-<VERSION>.tar.gz

   where

  `URL'
      Value of the option `ecb-download-url'.

  `PACKAGE'
      The string "ecb"

  `VERSION'
      Value of the option `ecb-download-version'.

 * Download and install of required packages:

   ECB checks at start-time if the required versions of semantic and
   eieio (see `README') are installed and loaded into Emacs. If not you
   will be asked if you want auto. download and install them. If you
   confirm this and the download and install succeeds then you will get
   a message-buffer which tells you something like:

      ---------------------------------------------------------------
      Current state of the required packages semantic and eieio:

      - semantic 1.4:
        Installed in /usr/local/lib/site-lisp/semantic-1.4

      - eieio 0.17:
        Correct version already loaded!

      After adding the new directory to your `load-path' and then
      restarting Emacs the new package(s) can be activated.
      ---------------------------------------------------------------

   *Note*: By setting the option `ecb-version-check' to `nil' you can
   prevent ECB from checking correct versions of semantic and eieio,
   but it's strongly recommended not to do this!

---------- Footnotes ----------

(1) cygwin is available at <http://cygwin.com/>

Automatic upgrading of options
==============================

User interface for option-upgrading
-----------------------------------

There are two interactive commands (see Interactive ECB commands):

 - `ecb-upgrade-options': Does all necessary beginning with a
   incompatibility-check for all options, upgrading/resetting
   incompatible options and ending with the display of all upgraded or
   reset options.

 - `ecb-display-upgraded-options': Displays a temp. buffer with all
   upgraded or resetted ECB-options with their old and new values.

If the option `ecb-auto-compatibility-check' has a non-nil value (which
is the default) then ECB does all this stuff automatically at startup.
This is very recommended!

If you are interested in some background information, read
Background information!

Background information
----------------------

Big packages like ECB will be enhanced and developed continously so
sometimes a new version must be released. Such packages offer in
general a lot of customizable options so probably some of these options
change the type or are renamed because the old type and/or name of the
option makes no sense in the new release.

Especially options which have changed the type of their value are now a
problem for the user which want to upgrade to the latest ECB-version:
If the user has saved a certain value for option X in its file `.emacs'
but the type of this saved value doesn't match the new defined type in
the defcustom-form after an ECB-upgrade then there can occur serious
problems like ECB can not be started anymore or even Emacs can not be
startet without errors.

Until now there was only one way to fix these problems: The user must
manually edit his file `.emacs' and remove all entries for options
which have now another type. After this and after restarting Emacs the
new default-values of the type-changed options in the new ECB-release
are active and the user can go on using Emacs and ECB. But this
approach to fix the incompatible-option-problem has two serious
drawbacks:

1. The user must manually edit the customize-section in his file
   `.emacs'. This should normally not be done and if then only by
   old-handed Emacs-users.

2. The customized value of the option X in the old-release (with the old
   type) is lost because after removing the related entry from the file
   `.emacs' the new default-value is active, so the user must
   re-customize the option X.

Ok, this is one half of the option-upgrade-problem but a new ECB-release
can also rename a option from name X to name Y because the new name Y
makes much more sense and/or is more mnemonic. If only the name has
changed but not the type this is not a serious problem like above but
also annoying because the customized value of the old-option X takes no
effect in the new release but instead the default-value of the
new-option Y is now active.  But nevertheless this problem has the
drawback number 2 (see above).

The last category of upgrade-problems is a renamed option which has also
changed its type.

ECB has a solution for all these problems:

 * It checks all customized values of all ECB-optons if they are still
   type-compatible. If not then it tries to upgrade the old-value to the
   new value-type and if this is not possible then it resets the option
   to the new default value and store it via customize in the
   .emacs-file (or in any file which is used for customized options).

 * It offers a special constant `ecb-upgradable-option-alist' which
   allows the ECB-maintainers to define special transformings for
   renamed options so even the value of an old-option X can be savely
   transformed to the new-option Y and the old setting is not lost.

All these checks and transformings are done at beginning of activating
ECB - if the option `ecb-auto-compatibility-check' is not nil. If ECB
has recognized incompatible or renamed options it does its
upgrading/reseting-job so all ECB-options have correct types so ECB can
start correct. After ECB is started it displays a list of all upgraded
or resetted option with their old and new values.

Tips and tricks
***************

This chapter contains some tips and tricks how to deal best with some
situations.

Changing faces in the ECB tree-buffers
======================================

There are two basic faces:

 * `ecb-default-general-face':

   Basic face for displaying an ECB-tree-buffer.

 * `ecb-default-highlight-face': Basic face for highlighting the
   current node in an ECB-tree-buffer.

With this faces you can change the basic attributes easily and fast for
ALL ECB-tree-buffers. But you are also able to display each
ECB-tree-buffer with different faces. For further details see the
doc-strings of the faces `ecb-default-general-face' and
`ecb-default-highlight-face' (just call `customize-face' to see the
doc-strings). The options of the group 'ecb-face-options' are also
interesting.

Working with small screens
==========================

If your screen is very small so you need every sqare-centimeter for
displaying the buffer which you want to edit, ECB offers you a special
layouts, where only the ECB-methods buffer is displayed on top or on
left-side. Here comes what you should/can do to work best with ECB in
such a situation:

 * First customize your ECB:

   1. Customize `ecb-layout-nr' to layout nr. 10 (on top) or nr. 11 (on
      left-side)

   2. Ensure that `ecb-compile-window-height' is nil.

   3. Optional: Ajust the `ecb-windows-height' resp.
      `ecb-windows-width'.

   4. Save your changes.

 * To edit your buffers: Call `ecb-toggle-ecb-windows' (also available
   via the menu "ECB" and by `C-c . w') or `ecb-hide-ecb-windows' to
   hide the ECB-method buffer so you get all the place of your screen
   for editing.

 * To browse and select functions: Call `ecb-toggle-ecb-windows' or
   `ecb-show-ecb-windows' to make the ECB-method buffer visible if not
   already. If you want select a method/variable with the keyboard
   instead with the mouse you should read the section Using the keyboard
   in this online help!

The possibility of hiding temporally the ECB windows like described
above is also useful for all the other layouts.

Simulating speedbar without an extra frame
==========================================

You can simulate a speedbar-like layout within ONE frame by doing the
following:

1. Customize `ecb-layout-nr' to layout nr. 11, 14, 15 or 16 dependend to
   what you like.

2. Optional: Ensure that `ecb-compile-window-height' is nil.

3. Optional: Ajust the `ecb-windows-width'.

4. Optional: Customize `ecb-toggle-layout-sequence' and toggle very fast
   between several layouts by `ecb-toggle-layout'. See the doc-strings!

5. Optional: Customize `ecb-show-sources-in-directories-buffer' to not
   nil if the choosen layout (see 1. and 4.) contains a
   directories-tree-buffer.

6. Save your changes.

Integrating speedbar in the ECB-frame
=====================================

This feature will be first available in future versions of ECB.

Optimize scrolling in the edit-window
=====================================

Emacs 20.X seems to slow down scrolling if there is a horizontal split
in the frame and/or a lot of overlays in the buffer which is scrolled.
This is independend of ECB! But because almost all layouts of ECB uses
horizontal splits of the frame and because ECB is based on semantic
which uses overlays intensively there can be poor scrolling performance
in large buffers, especially with java-buffers in `jde-mode'.

This scrolling performance can be increased a lot if the options
`scroll-conservatively' and `scroll-step' are set appropriatelly: The
former one should have a value of 0 during ECB is active and the latter
one a value of either 0 or > 1 (the exact value depends on the power of
your machine).

As far as we know this is not a problem of Emacs 21.X or XEmacs. With
these versions of Emacs there should be no scrolling problem even with
`scroll-step' has value 1.

Working with large directories
==============================

If `ecb-source-path' contains directories with many files and subdirs,
especially if these directories are mounted net-drives ("many" means
here something > 1000, dependend on the speed of the net-connection and
the machine), actualizing the sources- and/or directories- buffer of
ECB (if displayed in current layout!) can slow down dramatically.  If
this is a problem the contents of certain directories can be cached
which increases the speed a lot. See `ecb-cache-directory-contents'.

Optimal using of eshell in ECB
==============================

Documentation currently not available.

Entry points for elisp programmers
**********************************

This chapter describes how ECB can be used/programmed/driven by an
elisp-program. This contains:

Variables for elisp-programs
============================

Variables an elisp-program can use:

 * `ecb-source-path-functions'

Look at the documentation of these variables to get a description.

Available hooks of ECB
======================

The following hooks are available:

 * `ecb-activate-before-new-frame-created-hook'

 * `ecb-activate-before-layout-draw-hook'

 * `ecb-activate-hook'

 * `ecb-deactivate-hook'

 * `ecb-show-ecb-windows-hook'

 * `ecb-hide-ecb-windows-hook'

 * `ecb-current-buffer-sync-hook'

Look at the documentation of these hooks to get a description.

The library tree-buffer.el
==========================

The library tree-buffer.el is ECB independent and can be used for other
applications too. But such an application is not allowed to use any of
the variables of tree-buffer.el especially not the variable
*tree-buffers*!

`tree-buffers': Only for internal use. It contains all tree-buffers of
current Emacs-instance, means *all* tree-buffers of *all* applications
which uses currently tree-buffers. Every application must store its own
collection of tree-buffers in an own variable! For example: ECB stores
its tree-buffer set in `ecb-tree-buffers'!

An application may only use the methods tree-buffer.el provides but no
internal variables!

How to deal with the adviced window-functions
=============================================

ECB offers for packages which work during activated ECB three macros
for easy temporally(1) using all original-functions, all adviced
functions or only some adviced functions:

 - `ecb-with-original-functions'

 - `ecb-with-adviced-functions'

 - `ecb-with-some-adviced-functions'

For a detailed explanation of each macro read the documentation with
`describe-function'!

---------- Footnotes ----------

(1) I.e. regardless of the settings in `ecb-advice-window-functions'!

How to program new layouts
==========================

Documentation will be added in future!

Known conflicts and bugs of ECB
*******************************

This chapter describes all already known conflicts with other packages
and also the known (and currently unfixed) bugs of ECB. If possible
then a practicable solution or workaround is described.

Known conflicts with other packages
===================================

Here is a list of known conflicts of ECB with other packages and
helpful solutions/hints/workarounds:

Package VC (Version Control)
----------------------------

The variable `vc-delete-logbuf-window' must be set to nil during active
ECB. This can be done with the hooks mentioned in Elisp programming.

Package follow-mouse.el
-----------------------

The following is only relevant for Emacs 20.X!

ECB works very well with follow-mouse if follow-mouse is turned on
*BEFORE* ECB is activated (e.g. within the `ecb-activate-hook'). But if
you activate follow-mouse first after ECB is already activated, then
the follow-mouse stuff prevents the complete node-name to be displayed
in the echo-area if mouse moves over it. Because ECB has a much more
intelligent mouse tracking mechanism than follow-mouse the follow-mouse
stuff profit from ECB and works even better and saver as without
activated ECB!

Package avoid.el
----------------

With GNU Emacs 20.X ECB must deactivate `mouse-avoidance-mode' if the
option `ecb-show-node-info-in-minibuffer' activates for at least one
ECB tree-buffer 'if-too-long or 'always. This is done automatically but
only as long ECB is activated.

Package calendar.el
-------------------

With activated ECB `calendar' does not shrink it´s window to the small
size but splits the window equally. But if you add this to your
`.emacs' it works:

   (add-hook 'initial-calendar-window-hook
             (function (lambda ()
                         (when (and ecb-minor-mode
                                    (ecb-point-in-edit-window))
                           ;; if no horizontal split then nothing
                           ;; special to do
                           (or (= (frame-width) (window-width))
                               (shrink-window (- (window-height) 9))))
                        )))

Package calculator.el
---------------------

If the edit-window is already splitted then calling `calculator' uses
the whole "other" edit-window for the calculator. With an unsplitted
edit-window the calculator window has it´s normal size of about 2
lines. Therefore it´s recommended to set `calculator-electric-mode'
during ECB activation to not nil so calculator uses always the
echo-area instead of creating a new small window!

Known bugs
==========

This section describes all currently known bugs of ECB. The maintainers
of ECB try to fix these bugs as soon as possible.

Command Index
*************

This index contains all user commands of ECB:

Option Index
************

This index contains all customizable options of ECB: